

include $(YACLPATH)/control/gnuwin32.ctl


LIBS = base io ui


yacl:  $(LIBS)

everything: base io ui basedemo uidemos apps

.PHONY: libdir base io ui uidemos


libdir:
	-mkdir $(YACLPATH)/lib
	-mkdir $(YACLPATH)/lib/win32





base:
	- cd base && $(MAKE) -f gnuwin32.mak && cd .. 


io:
	- cd io && $(MAKE) -f gnuwin32.mak && cd .. 


ui:
	- cd ui && $(MAKE) -f gnuwin32.mak && cd .. 


uidemos:
	- cd uidemo && $(MAKE) -f gnuwin32.mak && cd ..

apps:
	- cd apps/bmpview; $(MAKE) -f gnuwin32.mak ; cd ../dlged
	- $(MAKE) -f gnuwin32.mak; cd ../..
        

clean:
	-rm -f base/*.o io/*.o ui/*.o 
	-rm -f lib/win32/libbase.a lib/win32/libui.a lib/win32/libui.a 
	-rm -f apps/dlged/*.obj apps/dlged/*.exe
	-rm -f apps/bmpview/*.obj apps/bmpview/*.exe
#	-cd uidemo && $(MAKE) -f gnuwin32.mak clean && cd ..
        

        



ZIP = zip

zip:
	-del yacl_all.zip
	find . -type f |  egrep -v \
        "\.(tr2|td2|ilk|pdb|dbg|lnk|ini|tr2|trw|tdw|td|log|lib|zip|bak|obj|exe|map|res|rws|vcp)$" | sort -u  | $(ZIP) yacl_all.zip -@

changezip:
	rm -f changes.zip
	find . -newer watmak.ctl \! \( -perm +u+x \) -print | \
        egrep -v '\.[oa]' | sort  | \
	$(ZIP) changes.zip -@

uizip:
	rm -f yaclui.zip
	(find ./ui ./uidemo \! \( -perm +u+x -o -name '*.o' -o -name \
        '*.a' \)  -print; ls ./*.ctl ./makefile.* ./changlog ./*.txt)| sort | \
	$(ZIP) yaclui.zip -@


