

#ifndef _stredevt_h_
#define _stredevt_h_


/*
 *
 *          Copyright (C) 1997, M. A. Sridhar
 *  
 *
 *     This software is Copyright M. A. Sridhar, 1997. You are free
 *     to copy, modify or distribute this software  as you see fit,
 *     and to use  it  for  any  purpose, provided   this copyright
 *     notice and the following   disclaimer are included  with all
 *     copies.
 *
 *                        DISCLAIMER
 *
 *     The author makes no warranties, either expressed or implied,
 *     with respect  to  this  software, its  quality, performance,
 *     merchantability, or fitness for any particular purpose. This
 *     software is distributed  AS IS.  The  user of this  software
 *     assumes all risks  as to its quality  and performance. In no
 *     event shall the author be liable for any direct, indirect or
 *     consequential damages, even if the  author has been  advised
 *     as to the possibility of such damages.
 *
 */


#include "ui/uidefs.h"

#include "base/string.h"
#include "ui/timer.h"
#include "ui/point.h"
#include "ui/interval.h"

class UI_StringEditor;
class UI_Event;
class UI_DwgSurfaceInMemory;
class UI_Point;

class YVE_StringEditorEventHandler {

public:
    YVE_StringEditorEventHandler (UI_StringEditor* editor);

    ~YVE_StringEditorEventHandler ();

protected:
    bool _HandleEvent (UI_Event& evt);

    void _DoKeyTyped (UI_Event&);

    void _DoFocus (bool);

    void _DoPaint ();

    bool _BlinkTimerTick ();

    virtual bool _DoInsert (short key);

    virtual long _IndexOfCharAt (const UI_Point& pt);

    void _DoMouseDown (UI_Event&);
  
    void _DoMouseMove (UI_Event&);
  
    void _DoMouseUp (UI_Event&);

    void _InvertCharRange (UI_DrawingSurface* sfc, const CL_Interval& range);
  
    UI_StringEditor*       _edit;
    UI_Timer               _blinkTimer;
    UI_Point               _mouseDownPt;
    long                   _visibleStartIndex;
    long                   _selectStartIndex;
    bool                   _blinkOn;
    bool                   _haveFocus;
    bool                   _mouseGrabbed;
    bool                   _inhibitRedraw;
};



#endif
